
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * A fast servlet for the JMeter test article
 * Uses StringBuffer appends to be
 * faster than the Slow servlet.
 *
 * @author Jeff Linwood
 */

public class FastJMeterExample extends HttpServlet {


    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
				//Tell the browser we're sending it html
        response.setContentType("text/html");

				StringBuffer myhtml = new StringBuffer();
				String addon = new String("<html>");
				myhtml.append(addon);

				addon = "<head>";
				myhtml.append(addon);

				addon = "<title>";
				myhtml.append(addon);

				addon = "Fast Example for JMeter";
				myhtml.append(addon);

				addon = "</title>";
				myhtml.append(addon);

				addon = "</head>";
				myhtml.append(addon);

				addon = "<body><h1>";
				myhtml.append(addon);

				myhtml.append("JMeter Fast Example Test");

				myhtml.append("</H1>");

				for (int ctr = 0; ctr < 512; ctr++) {

        	myhtml.append(ctr);
        	myhtml.append(" ");

				}

        myhtml.append("</body>");
        myhtml.append("</html>");

        PrintWriter out = response.getWriter();
        out.println(myhtml.toString());

    }
}



