// (C) 2000-2002 MetaCase Consulting, all rights reserved
// All this code is generated directly from the model.
// Since no manual coding or editing is needed, it is
// not intended to be particularly human-readable.
// Comments added here by hand for Dr. Dobbs' readers
// Note picture slightly different from article: 
// offset is buffered while editing (see SimpleTime.gif)

public class SimpleTime extends AbstractWatchApplication {
	// Define unique numbers for each Action (a...) and DisplayFn (d...)
	static final int a22_1405	= +1; //+1+1+1+1+1
	static final int a22_2926	= +1+1; //+1+1+1+1
	static final int a22_3285	= +1+1+1; //+1+1+1
	static final int a22_3288	= +1+1+1+1; //+1+1
	static final int d22_977	= +1+1+1+1+1; //+1
	static final int d22_3252	= +1+1+1+1+1+1; //

	// Define local variables in this application, and their accessors
	public METime tempOffset = new METime();

	public METime gettempOffset() {
		return tempOffset;
	}
	public void settempOffset(METime t1) {
		tempOffset = t1;
	}

	public SimpleTime(Master master) {
		super(master);

		// Transitions and their triggering buttons and actions
		// Arguments: From State, Button, Action, To State
		addTransition ("EditMinutes", "Set", a22_1405, "EditMinutes");
		addTransition ("EditHours", "Set", a22_2926, "EditHours");
		addTransition ("EditHours", "Mode", 0, "EditMinutes");
		addTransition ("Start [Watch]", "", 0, "Show");
		addTransition ("EditMinutes", "Mode", a22_3288, "Show");
		addTransition ("Show", "Mode", a22_3285, "EditHours");


		// What to display in each state
		// Arguments: State, blinking unit, central unit, DisplayFn
		addStateDisplay("EditHours", METime.HOUR_OF_DAY, METime.MINUTE, d22_3252);
		addStateDisplay("EditMinutes", METime.MINUTE, METime.MINUTE, d22_3252);
		addStateDisplay("Show", -1, METime.MINUTE, d22_977);
	};


	public Object perform(int methodId)
	{
		// Actions (return null) and DisplayFns (return time)
		switch (methodId) {
			case a22_1405:    // roll offset up one minute
				gettempOffset().roll(METime.MINUTE, true, displayTime());
				return null;
			case a22_2926:    // roll offset up one hour
				gettempOffset().roll(METime.HOUR_OF_DAY, true, displayTime());
				return null;
			case a22_3285:    // apply edited offset
				settempOffset(getclockOffset());
				return null;
			case a22_3288:    // copy offset for editing
				setclockOffset(gettempOffset());
				return null;
			case d22_977:     // time to display is simply the time
				return getclockTime();
			case d22_3252:    // time to display is system time + edited offset
				return getsysTime().mePlus(gettempOffset());
		}
		return null;
	}
}
