
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * A slow servlet for the JMeter test article
 * Uses String concatenation to get a slow servlet.
 *
 * @author Jeff Linwood
 */

public class SlowJMeterExample extends HttpServlet {


    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
				//Tell the browser we're sending it html
        response.setContentType("text/html");

				String myhtml = new String("");
				String addon = new String("<html>");

				myhtml = myhtml.concat(addon);

				addon = "<head>";
				myhtml = myhtml.concat(addon);

				addon = "<title>";
				myhtml = myhtml.concat(addon);

				addon = "Slow Example for JMeter";
				myhtml = myhtml.concat(addon);

				addon = "</title>";
				myhtml = myhtml.concat(addon);

				addon = "</head>";
				myhtml = myhtml.concat(addon);

				addon = "<body><h1>";
				myhtml = myhtml.concat(addon);

				myhtml = myhtml.concat("JMeter Slow Example Test");

				myhtml = myhtml.concat("</H1>");

				for (int ctr = 0; ctr < 512; ctr++) {

        	myhtml = myhtml.concat(String.valueOf(ctr));
        	myhtml = myhtml.concat(" ");

				}

        myhtml = myhtml.concat("</body>");
        myhtml = myhtml.concat("</html>");

        PrintWriter out = response.getWriter();
        out.println(myhtml);

    }
}



